## inn2 2.7.2~20240212

=== history/Makefile ===
include ../Makefile.global

# This version number should be increased with every change to the library
# source following the rules laid out in the libtool manual.  This will also
# force the file name of the shared library to change so that one can
# recover from make update.  We can't use .OLD extensions for the shared
# library since ldconfig will think .OLD sorts after the regular library and
# will point the binaries at the old library.
LTVERSION     = 3:7:0

top           = ..
CFLAGS        = $(GCFLAGS) -I.

SOURCES       = his.c hismethods.c $(METHOD_SOURCES)
OBJECTS       = $(SOURCES:.c=.o)
LOBJECTS      = $(OBJECTS:.o=.lo)

.SUFFIXES: .lo

all: library programs

# Included here after the all target, since additional rules are defined in
# Make.methods to be sure that we recurse properly to build the methods.
include Make.methods

warnings:
	$(MAKE) COPT="$(COPT) $(WARNINGS)" all

install: all
	$(LI_LPUB) libinnhist.$(EXTLIB) $D$(PATHLIB)/libinnhist.$(EXTLIB)

bootstrap: Make.methods

library: libinnhist.$(EXTLIB)

programs: $(PROGRAMS)

clean clobber distclean:
	rm -f *.o *.lo */*.o */*.lo libinnhist.la libinnhist.a
	rm -f libinnhist_pure_*.a .pure $(PROGRAMS)
	rm -f buildconfig profiled libinnhist$(PROFSUFFIX).a
	rm -rf .libs */.libs

maintclean: distclean
	rm -f Make.methods hismethods.c hismethods.h

$(FIXSCRIPT):
	@echo Run configure before running make.  See INSTALL for details.
	@exit 1

FIX	= $(SHELL) $(FIXSCRIPT)

libinnhist.la: $(OBJECTS) $(LOBJECTS) $(LIBSTORAGE) $(LIBINN)
	$(LIBLD) $(LDFLAGS) -o $@ $(LOBJECTS) \
	    $(LIBSTORAGE) $(LIBINN) $(STORAGE_LIBS) $(LIBS) \
	    -rpath $(PATHLIB) -version-info $(LTVERSION)

libinnhist.a: $(OBJECTS)
	ar r $@ $(OBJECTS)
	$(RANLIB) libinnhist.a

# Try to set up these rules so that buildconfig is only run once.
# Make.methods is included in the distribution tarball since some non-GNU
# makes can't deal with including a non-existent file, so don't depend on
# it.  The dependencies aren't entirely accurate; you really want to re-run
# buildconfig each time a new subdirectory is added to the directory.  But
# adding a dependency on . is a bit too non-portable for my taste and causes
# too many rebuilds.
Make.methods hismethods.h hismethods.c: buildconfig
	./buildconfig

buildconfig: buildconfig.in $(FIXSCRIPT)
	$(FIX) -i buildconfig.in

.c.o .c.lo:
	$(LIBCC) $(CFLAGS) $(CCOUTPUT)

$(LIBINN):      ; (cd ../lib ; $(MAKE))
$(LIBSTORAGE):	; (cd ../storage ; $(MAKE) library)


##  Profiling.  The rules are a bit brute-force, but good enough.

profiled: libinnhist$(PROFSUFFIX).a
	date >$@

libinnhist$(PROFSUFFIX).a: $(SOURCES)
	rm -f $(OBJECTS)
	$(MAKEPROFILING) libinnhist.a
	mv libinnhist.a libinnhist$(PROFSUFFIX).a
	$(RANLIB) libinnhist$(PROFSUFFIX).a
	rm -f $(OBJECTS)


##  Dependencies.  Default list, below, is probably good enough.

depend:	$(SOURCES) $(EXTRA_SOURCES)
	$(MAKEDEPEND) '$(CFLAGS)' $(SOURCES) $(EXTRA_SOURCES)

# DO NOT DELETE THIS LINE -- make depend depends on it.
his.o: his.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/history.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/storage.h \
  ../include/inn/options.h ../include/inn/timer.h hisinterface.h \
  hismethods.h
hismethods.o: hismethods.c hisinterface.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h hismethods.h hisv6/hisv6.h
hisv6/hisv6.o: hisv6/hisv6.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h hisinterface.h hisv6/hisv6-private.h \
  ../include/inn/history.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/storage.h \
  ../include/inn/options.h hisv6/hisv6.h ../include/inn/dbz.h \
  ../include/inn/fdflag.h ../include/inn/portable-socket.h \
  ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/innconf.h \
  ../include/inn/inndcomm.h ../include/inn/qio.h ../include/inn/sequence.h \
  ../include/inn/timer.h

=== innd/Makefile ===
include ../Makefile.global

top	        = ..
CFLAGS		= $(GCFLAGS) $(SYSTEMD_CFLAGS)

ALL		= innd tinyleaf

SOURCES		= art.c cc.c chan.c icd.c innd.c keywords.c lc.c nc.c \
		  newsfeeds.c ng.c perl.c proc.c python.c rc.c site.c \
		  status.c util.c wip.c

EXTRASOURCES	= tinyleaf.c

OBJECTS		= $(SOURCES:.c=.o)

all: $(ALL)

warnings:
	$(MAKE) COPT="$(COPT) $(WARNINGS)" all

install: all
	$(LI_XPRI) innd $D$(PATHBIN)/innd
	$(LI_XPUB) tinyleaf $D$(PATHBIN)/tinyleaf

bootstrap:

clean clobber distclean maintclean:
	rm -f *.o $(ALL) inndp
	rm -rf .libs


##  Compilation rules.

INNDLIBS 	= $(LIBSTORAGE) $(LIBHIST) $(LIBINN) $(STORAGE_LIBS) \
		  $(SYSTEMD_LIBS) $(CANLOCK_LDFLAGS) $(CANLOCK_LIBS) \
		  $(PERL_LIBS) $(PYTHON_LIBS) $(REGEX_LIBS) $(LIBS)

perl.o:		perl.c   ; $(CC) $(CFLAGS) $(PERL_CPPFLAGS) -c perl.c
python.o:	python.c ; $(CC) $(CFLAGS) $(PYTHON_CPPFLAGS) -c python.c

innd: $(OBJECTS) $(LIBSTORAGE) $(LIBHIST) $(LIBINN)
	$(LIBLD) $(LDFLAGS) -o $@ $(OBJECTS) $(INNDLIBS)

tinyleaf: tinyleaf.o $(LIBINN)
	$(LIBLD) $(LDFLAGS) -o $@ tinyleaf.o $(LIBINN) $(LIBS)

$(LIBINN):	; (cd ../lib ; $(MAKE))
$(LIBSTORAGE):	; (cd ../storage ; $(MAKE) library)
$(LIBHIST):	; (cd ../history ; $(MAKE))


##  Profiling.  These rules have not been checked for a while and may need
##  some work.

profiled: inndp

inndp: $(SOURCES)
	rm -f $(OBJECTS)
	$(MAKEPROFILING) innd
	mv innd inndp
	rm -f $(OBJECTS)


##  Dependencies.  Default list, below, is probably good enough.

depend:	Makefile $(SOURCES) $(EXTRASOURCES)
	$(MAKEDEPEND) '$(CFLAGS) $(PERL_CPPFLAGS) $(PYTHON_CPPFLAGS)' \
	    $(SOURCES) $(EXTRASOURCES)

# DO NOT DELETE THIS LINE -- make depend depends on it.
art.o: art.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/md5.h ../include/inn/system.h ../include/inn/ov.h \
  ../include/inn/history.h ../include/inn/storage.h \
  ../include/inn/options.h ../include/inn/overview.h \
  ../include/inn/vector.h ../include/inn/wire.h innd.h \
  ../include/portable/sd-daemon.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/buffer.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/xmalloc.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/nntp.h ../include/inn/paths.h \
  ../include/inn/timer.h
cc.o: cc.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/portable/socket-unix.h \
  ../include/inn/fdflag.h ../include/inn/portable-socket.h \
  ../include/inn/system.h ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/portable-stdbool.h \
  ../include/inn/innconf.h ../include/inn/macros.h \
  ../include/inn/inndcomm.h ../include/inn/qio.h innd.h \
  ../include/portable/sd-daemon.h ../include/portable/socket.h \
  ../include/inn/buffer.h ../include/inn/history.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/nntp.h ../include/inn/paths.h \
  ../include/inn/storage.h ../include/inn/options.h ../include/inn/timer.h \
  ../include/inn/vector.h ../include/innperl.h ../include/config.h
chan.o: chan.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/fdflag.h \
  ../include/inn/portable-socket.h ../include/inn/system.h \
  ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/portable-stdbool.h \
  ../include/inn/innconf.h ../include/inn/macros.h \
  ../include/inn/network.h innd.h ../include/portable/sd-daemon.h \
  ../include/portable/socket.h ../include/inn/buffer.h \
  ../include/inn/history.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/xmalloc.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/nntp.h ../include/inn/paths.h \
  ../include/inn/storage.h ../include/inn/options.h ../include/inn/timer.h \
  ../include/inn/vector.h
icd.o: icd.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/portable/mmap.h \
  ../include/inn/fdflag.h ../include/inn/portable-socket.h \
  ../include/inn/system.h ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/portable-stdbool.h \
  ../include/inn/innconf.h ../include/inn/macros.h ../include/inn/mmap.h \
  ../include/inn/ov.h ../include/inn/history.h ../include/inn/storage.h \
  ../include/inn/options.h innd.h ../include/portable/sd-daemon.h \
  ../include/portable/socket.h ../include/inn/buffer.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/xwrite.h ../include/inn/messages.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/timer.h ../include/inn/vector.h
innd.o: innd.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/messages.h ../include/inn/newsuser.h ../include/innperl.h \
  ../include/config.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/storage.h ../include/inn/options.h innd.h \
  ../include/portable/sd-daemon.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/buffer.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/nntp.h ../include/inn/paths.h ../include/inn/timer.h \
  ../include/inn/vector.h
keywords.o: keywords.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/innconf.h \
  innd.h ../include/portable/sd-daemon.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/buffer.h ../include/inn/history.h \
  ../include/inn/messages.h ../include/inn/nntp.h ../include/inn/paths.h \
  ../include/inn/storage.h ../include/inn/options.h ../include/inn/timer.h \
  ../include/inn/vector.h
lc.o: lc.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h innd.h \
  ../include/portable/sd-daemon.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/buffer.h ../include/inn/history.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/messages.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/timer.h ../include/inn/vector.h \
  ../include/portable/socket-unix.h
nc.o: nc.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/qio.h ../include/inn/version.h innd.h \
  ../include/portable/sd-daemon.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/buffer.h ../include/inn/history.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/messages.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/timer.h ../include/inn/vector.h
newsfeeds.o: newsfeeds.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h innd.h \
  ../include/portable/sd-daemon.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/buffer.h ../include/inn/history.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/messages.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/timer.h ../include/inn/vector.h
ng.o: ng.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/ov.h ../include/inn/history.h ../include/inn/storage.h \
  ../include/inn/options.h innd.h ../include/portable/sd-daemon.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/buffer.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/nntp.h ../include/inn/paths.h \
  ../include/inn/timer.h ../include/inn/vector.h
perl.o: perl.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/wire.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h innd.h \
  ../include/portable/sd-daemon.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/buffer.h ../include/inn/history.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/messages.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/timer.h ../include/inn/vector.h \
  ../include/ppport.h \
  ../include/innperl.h \

=== innfeed/Makefile ===
include ../Makefile.global

top	      = ..
CFLAGS	      = $(GCFLAGS) $(SASLINC)

ALL	      = innfeed procbatch imapfeed

SOURCES	      = article.c buffer.c config_l.c config_y.c connection.c endpoint.c \
		host.c imap_connection.c innlistener.c main.c misc.c \
		tape.c

INCLUDES      = article.h buffer.h configfile.h config_y.h connection.h \
		endpoint.h host.h innfeed.h innlistener.h misc.h tape.h

# The objects linked into innfeed.  All SOURCES except connection.o or
# imap_connection.o.
OBJECTS	      = article.o buffer.o config_l.o config_y.o endpoint.o host.o \
		innlistener.o main.o misc.o tape.o

all: $(ALL)

warnings:
	$(MAKE) COPT="$(COPT) $(WARNINGS)" all

install: all
	$(LI_XPRI) innfeed $D$(PATHBIN)/innfeed
	$(LI_XPRI) imapfeed $D$(PATHBIN)/imapfeed
	$(CP_XPRI) procbatch $D$(PATHBIN)/procbatch

bootstrap: config_y.c config_y.h config_l.c

clean:
	rm -f *.o $(ALL)
	rm -f innfeedp
	rm -rf .libs

clobber distclean: clean
	rm -f y.tab.c y.tab.h lex.yy.c

maintclean: distclean
	rm -f config_l.c config_y.c config_y.h

$(FIXSCRIPT):
	@echo Run configure before running make.  See INSTALL for details.
	@exit 1

FIX	= $(SHELL) $(FIXSCRIPT)

##  Compilation rules.

INNFEEDLIBS	= $(LIBSTORAGE) $(LIBHIST) $(LIBINN) $(STORAGE_LIBS) $(LIBS)

config_y.c config_y.h: configfile.y
	$(YACC) -d configfile.y
	mv y.tab.h config_y.h
	mv y.tab.c config_y.c
	touch config_y.h

config_y.h: config_y.c

config_l.c: configfile.l
	$(LEX) $?
	mv lex.yy.c config_l.c

imap_connection.o: imap_connection.c
	$(CC) $(CFLAGS) $(SASL_CPPFLAGS) -c $<

innfeed: $(OBJECTS) connection.o $(LIBSTORAGE) $(LIBINN)
	$(LIBLD) $(LDFLAGS) -o $@ $(OBJECTS) connection.o $(INNFEEDLIBS)

imapfeed: $(OBJECTS) imap_connection.o $(LIBSTORAGE) $(LIBINN)
	$(LIBLD) $(LDFLAGS) -o $@ $(OBJECTS) imap_connection.o \
	    $(SASL_LDFLAGS) $(SASL_LIBS) $(INNFEEDLIBS)

procbatch: procbatch.in $(FIXSCRIPT)
	$(FIX) procbatch.in

tst: config_y.c config_l.c
	gcc -DWANT_MAIN -o tst -g -Wall config_y.c config_l.c -ly -ll

$(LIBINN):	; (cd ../lib ; $(MAKE))
$(LIBSTORAGE):	; (cd ../storage ; $(MAKE) library)
$(LIBHIST):	; (cd ../history ; $(MAKE))


##  Profiling.  These rules have not been checked for a while and may need
##  some work.

profiled: innfeedp

innfeedp: $(SOURCES)
	rm -f $(OBJECTS)
	$(MAKEPROFILING) innfeed
	mv innfeed innfeedp
	rm -f $(OBJECTS)


##  Dependencies.  Default list, below, is probably good enough.

depend: Makefile $(SOURCES)
	$(MAKEDEPEND) '$(CFLAGS)' $(SOURCES)

# DO NOT DELETE THIS LINE -- make depend depends on it.
article.o: article.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/portable/mmap.h \
  ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/storage.h \
  ../include/inn/options.h article.h misc.h buffer.h endpoint.h
buffer.o: buffer.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h buffer.h misc.h
config_l.o: config_l.c innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/portable/stdbool.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/portable-stdbool.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  configfile.h config_y.h misc.h ../include/portable/macros.h
config_y.o: config_y.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h configfile.h misc.h
connection.o: connection.c ../include/portable/system.h \
  ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/macros.h ../include/portable/stdbool.h innfeed.h \
  ../include/inn/timer.h ../include/inn/macros.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/fdflag.h \
  ../include/inn/portable-socket.h ../include/inn/portable-stdbool.h \
  ../include/inn/innconf.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/network.h article.h misc.h \
  buffer.h configfile.h connection.h endpoint.h host.h
endpoint.o: endpoint.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/innconf.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h buffer.h misc.h configfile.h endpoint.h host.h
host.o: host.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/innconf.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/network.h \
  ../include/inn/portable-socket.h ../include/inn/version.h article.h \
  misc.h buffer.h configfile.h connection.h endpoint.h host.h \
  innlistener.h tape.h
imap_connection.o: imap_connection.c ../include/portable/system.h \
  ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/macros.h ../include/portable/stdbool.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h article.h misc.h buffer.h configfile.h \
  connection.h endpoint.h host.h innfeed.h ../include/inn/timer.h
innlistener.o: innlistener.c ../include/portable/system.h \
  ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/macros.h ../include/portable/stdbool.h innfeed.h \
  ../include/inn/timer.h ../include/inn/macros.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/portable-stdbool.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/nntp.h article.h misc.h \
  buffer.h configfile.h endpoint.h host.h innlistener.h tape.h
main.o: main.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/portable/socket-unix.h ../include/inn/innconf.h \
  ../include/inn/portable-stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/messages.h \
  ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/version.h article.h misc.h buffer.h configfile.h \
  connection.h endpoint.h host.h innlistener.h tape.h
misc.o: misc.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h endpoint.h misc.h tape.h
tape.o: tape.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h innfeed.h ../include/inn/timer.h \
  ../include/inn/macros.h ../include/inn/innconf.h \
  ../include/inn/portable-stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/messages.h article.h misc.h \
  configfile.h endpoint.h host.h tape.h

=== lib/Makefile ===
include ../Makefile.global

# This version number should be increased with every change to the library
# source following the rules laid out in the libtool manual.  This will also
# force the file name of the shared library to change so that one can
# recover from make update.  We can't use .OLD extensions for the shared
# library since ldconfig will think .OLD sorts after the regular library and
# will point the binaries at the old library.
LTVERSION     = 9:0:0

top	= ..
CFLAGS  = $(GCFLAGS)

# The base library files that are always compiled and included.
SOURCES       = argparse.c artnumber.c buffer.c cleanfrom.c clientactive.c \
	        clientlib.c                                                \
	        commands.c concat.c conffile.c confparse.c                 \
	      	date.c dbz.c defdist.c dispatch.c fdflag.c fdlimit.c	   \
	      	getfqdn.c getmodaddr.c hash.c hashtab.c headers.c hex.c	   \
		innconf.c inndcomm.c list.c localopen.c lockfile.c         \
	      	makedir.c md5.c messageid.c messages.c mmap.c network.c	   \
	        network-innbind.c newsuser.c nntp.c qio.c                  \
		radix32.c readin.c					   \
		remopen.c reservedfd.c resource.c secrets.c sendarticle.c  \
	        sendpass.c						   \
	      	sequence.c timer.c tst.c uwildmat.c vector.c wire.c	   \
	      	xfopena.c xmalloc.c xsignal.c xwrite.c

# Sources for additional functions only built to replace missing system ones.
EXTRA_SOURCES = asprintf.c daemon.c fseeko.c ftello.c getaddrinfo.c        \
		getnameinfo.c getpagesize.c inet_aton.c inet_ntoa.c	   \
		inet_ntop.c mkstemp.c pread.c pwrite.c                     \
	        reallocarray.c sd-daemon.c setenv.c                        \
		seteuid.c setproctitle.c snprintf.c strcasecmp.c strlcat.c \
		strlcpy.c strspn.c strtok.c symlink.c

OBJECTS       = $(LIBOBJS) $(SOURCES:.c=.o)
LOBJECTS      = $(OBJECTS:.o=.lo)

.SUFFIXES: .lo

all: libinn.$(EXTLIB) canlock.o perl.o

warnings:
	$(MAKE) COPT="$(COPT) $(WARNINGS)" all

install: all
	$(LI_LPUB) libinn.$(EXTLIB) $D$(PATHLIB)/libinn.$(EXTLIB)

bootstrap:

clean clobber distclean maintclean:
	rm -f *.o *.lo libinn.la libinn.a
	rm -f profiled perl$(PROFSUFFIX).o libinn$(PROFSUFFIX).a
	rm -f libinn_pure_*.a .pure
	rm -rf .libs

libinn.la: $(OBJECTS) $(LOBJECTS)
	$(LIBLD) $(LDFLAGS) -o $@ $(LOBJECTS) $(LIBS) \
	    -rpath $(PATHLIB) -version-info $(LTVERSION)

libinn.a: $(OBJECTS)
	ar r $@ $(OBJECTS)
	$(RANLIB) libinn.a

.c.o .c.lo:
	$(LIBCC) $(CFLAGS) -c $*.c

canlock.o: canlock.c
	$(CC) $(CFLAGS) $(CANLOCK_CPPFLAGS) -c canlock.c

perl.o: perl.c
	$(CC) $(CFLAGS) $(PERL_CPPFLAGS) -c perl.c

../include/inn/system.h:
	(cd ../include && $(MAKE))

##  Profiling.  The rules are a bit brute-force, but good enough.
profiled: libinn$(PROFSUFFIX).a perl$(PROFSUFFIX).o
	date >$@

libinn$(PROFSUFFIX).a perl$(PROFSUFFIX).o: $(OBJECTS) perl.o
	rm -f $(OBJECTS)
	$(MAKEPROFILING) libinn.a
	$(MAKEPROFILING) perl.o
	mv libinn.a libinn$(PROFSUFFIX).a
	mv perl.o perl$(PROFSUFFIX).o
	$(RANLIB) libinn$(PROFSUFFIX).a
	rm -f $(OBJECTS)

##  Dependencies.  Default list, below, is probably good enough.

depend: Makefile $(SOURCES) $(EXTRA_SOURCES) canlock.c perl.c \
	    ../include/inn/system.h
	$(MAKEDEPEND) '$(CFLAGS) $(CANLOCK_CPPFLAGS) $(PERL_CPPFLAGS)' \
	    $(SOURCES) $(EXTRA_SOURCES) canlock.c perl.c

# DO NOT DELETE THIS LINE -- make depend depends on it.
argparse.o: argparse.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h
artnumber.o: artnumber.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h
buffer.o: buffer.c ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/system.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/buffer.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h
cleanfrom.o: cleanfrom.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h
clientactive.o: clientactive.c ../include/portable/system.h \
  ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/macros.h ../include/portable/stdbool.h \
  ../include/inn/innconf.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/nntp.h ../include/inn/paths.h
clientlib.o: clientlib.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/nntp.h
commands.o: commands.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h
concat.o: concat.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/concat.h \
  ../include/inn/macros.h ../include/inn/messages.h \
  ../include/inn/xmalloc.h ../include/inn/system.h
conffile.o: conffile.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/conffile.h \
  ../include/portable/macros.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h
confparse.o: confparse.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/confparse.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/hashtab.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/vector.h
date.o: date.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h
dbz.o: dbz.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/portable/mmap.h \
  ../include/inn/dbz.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/fdflag.h ../include/inn/portable-socket.h \
  ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/innconf.h \
  ../include/inn/messages.h ../include/inn/mmap.h
defdist.o: defdist.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/paths.h
dispatch.o: dispatch.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/dispatch.h \
  ../include/inn/vector.h
fdflag.o: fdflag.c ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/system.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/fdflag.h \
  ../include/inn/portable-socket.h ../include/inn/system.h \
  ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/portable-stdbool.h \
  ../include/inn/macros.h
fdlimit.o: fdlimit.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h
getfqdn.o: getfqdn.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h
getmodaddr.o: getmodaddr.c ../include/portable/system.h \

=== nnrpd/Makefile ===
include ../Makefile.global

top		= ..
CFLAGS		= $(GCFLAGS) $(SSL_CPPFLAGS) $(SASL_CPPFLAGS) $(ZLIB_CPPFLAGS) \
		  $(BLACKLIST_CPPFLAGS)

ALL		= nnrpd

SOURCES		= article.c auth-ext.c cache.c commands.c group.c line.c \
		  list.c misc.c newnews.c nnrpd.c perl.c perm.c post.c \
		  python.c sasl.c tls.c track.c zlib.c

INCLUDES	= cache.h nnrpd.h post.h tls.h

OBJECTS		= $(SOURCES:.c=.o)

all: $(ALL)

warnings:
	$(MAKE) COPT="$(COPT) $(WARNINGS)" all

install: all
	$(LI_XPUB) nnrpd $D$(PATHBIN)/nnrpd

bootstrap:

clean clobber distclean maintclean:
	rm -f *.o $(ALL) nnrpdp profiled
	rm -rf .libs


##  Compilation rules.

NNRPDLIBS	= $(LIBSTORAGE) $(LIBHIST) $(LIBINN) $(STORAGE_LIBS) \
		  $(PERL_LIBS) $(PYTHON_LIBS) \
		  $(CANLOCK_LDFLAGS) $(CANLOCK_LIBS) \
		  $(SSL_LDFLAGS) $(SSL_LIBS) \
		  $(CRYPTO_LIBS) $(SASL_LDFLAGS) $(SASL_LIBS) \
		  $(ZLIB_LDFLAGS) $(ZLIB_LIBS) \
		  $(BLACKLIST_LDFLAGS) $(BLACKLIST_LIBS) \
		  $(LIBS)

.c.o:
	$(CC) $(CFLAGS) -c $<

perl.o:		perl.c   ; $(CC) $(CFLAGS) $(PERL_CPPFLAGS) -c perl.c
python.o:	python.c ; $(CC) $(CFLAGS) $(PYTHON_CPPFLAGS) -c python.c

nnrpd: $(OBJECTS) $(LIBHIST) $(LIBSTORAGE) $(LIBINN)
	$(LIBLD) $(LDFLAGS) -o $@ $(OBJECTS) $(NNRPDLIBS)

$(LIBINN):	; (cd ../lib ; $(MAKE))
$(LIBSTORAGE):	; (cd ../storage ; $(MAKE) library)
$(LIBHIST):	; (cd ../history ; $(MAKE))


##  Profiling.  These rules have not been checked for a while and may need
##  some work.

profiled: nnrpdp

nnrpdp: $(SOURCES)
	rm -f $(OBJECTS)
	$(MAKEPROFILING) nnrpd
	mv nnrpd nnrpdp
	rm -f $(OBJECTS)


##  Dependencies.  Default list, below, is probably good enough.

depend:	$(SOURCES)
	$(MAKEDEPEND) '$(CFLAGS) $(PERL_CPPFLAGS) $(PYTHON_CPPFLAGS)' \
	    $(SOURCES)

# DO NOT DELETE THIS LINE -- make depend depends on it.
article.o: article.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h cache.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/storage.h \
  ../include/inn/options.h ../include/inn/innconf.h \
  ../include/inn/messages.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/overview.h ../include/inn/wire.h nnrpd.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/qio.h ../include/inn/timer.h \
  ../include/inn/vector.h tls.h
auth-ext.o: auth-ext.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/buffer.h \
  ../include/inn/portable-stdbool.h ../include/inn/messages.h \
  ../include/inn/vector.h nnrpd.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/nntp.h ../include/inn/paths.h ../include/inn/qio.h \
  ../include/inn/storage.h ../include/inn/options.h ../include/inn/timer.h
cache.o: cache.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/list.h \
  ../include/inn/storage.h ../include/inn/options.h ../include/inn/tst.h \
  cache.h
commands.o: commands.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/fdflag.h \
  ../include/inn/portable-socket.h ../include/inn/system.h \
  ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/portable-stdbool.h \
  ../include/inn/innconf.h ../include/inn/macros.h \
  ../include/inn/messages.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/version.h nnrpd.h ../include/portable/socket.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/xwrite.h ../include/inn/nntp.h ../include/inn/paths.h \
  ../include/inn/qio.h ../include/inn/timer.h ../include/inn/vector.h \
  tls.h
group.o: group.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/ov.h ../include/inn/history.h ../include/inn/storage.h \
  ../include/inn/options.h nnrpd.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/qio.h ../include/inn/timer.h \
  ../include/inn/vector.h
line.o: line.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/messages.h nnrpd.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/qio.h ../include/inn/storage.h \
  ../include/inn/options.h ../include/inn/timer.h ../include/inn/vector.h \
  tls.h
list.o: list.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/messages.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/overview.h nnrpd.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/qio.h ../include/inn/timer.h \
  ../include/inn/vector.h
misc.o: misc.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h nnrpd.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/nntp.h ../include/inn/paths.h \
  ../include/inn/qio.h ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/timer.h ../include/inn/vector.h tls.h ../include/inn/ov.h \
  ../include/inn/history.h
newnews.o: newnews.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h cache.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/storage.h \
  ../include/inn/options.h ../include/inn/innconf.h \
  ../include/inn/messages.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/overview.h ../include/inn/wire.h nnrpd.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/qio.h ../include/inn/timer.h \
  ../include/inn/vector.h
nnrpd.o: nnrpd.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/portable/setproctitle.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/network-innbind.h \
  ../include/inn/portable-socket.h ../include/inn/network.h \
  ../include/inn/newsuser.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/overview.h ../include/inn/secrets.h \
  ../include/inn/version.h nnrpd.h ../include/inn/nntp.h \
  ../include/inn/paths.h ../include/inn/qio.h ../include/inn/timer.h \
  ../include/inn/vector.h tls.h
perl.o: perl.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/nntp.h ../include/inn/paths.h nnrpd.h \
  ../include/portable/socket.h ../include/portable/getaddrinfo.h \
  ../include/portable/getnameinfo.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/system.h \
  ../include/inn/xwrite.h ../include/inn/qio.h ../include/inn/storage.h \
  ../include/inn/options.h ../include/inn/timer.h ../include/inn/vector.h \
  post.h \
  ../include/ppport.h \
  ../include/innperl.h \
  ../include/config.h
perm.o: perm.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/conffile.h \
  ../include/portable/macros.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/network.h ../include/inn/portable-socket.h \
  ../include/inn/system.h ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/innperl.h \
  ../include/config.h nnrpd.h ../include/portable/socket.h \

=== site/Makefile ===
include ../Makefile.global
top = ..

##  If you want to do ctlinnd pause/reload/go, uncomment these lines.
#PAUSE		= pause
#RELOAD_AND_GO	= reload go
DIFF="diff"

# Added a default rule for ".csh" because Digital UNIX has a builtin
# rule which would overwite the innshellvars file.
.csh:

CTLINND			= ${PATHBIN}/ctlinnd
FILTBIN			= ${PATHFILTER}
PATH_PERL_STARTUP_INND	= ${PATHFILTER}/startup_innd.pl
PATH_PERL_FILTER_INND	= ${PATHFILTER}/filter_innd.pl
PATH_PERL_FILTER_NNRPD	= ${PATHFILTER}/filter_nnrpd.pl
PATH_PYTHON_FILTER_INND = ${PATHFILTER}/filter_innd.py
PATH_PYTHON_INN_MODULE  = ${PATHFILTER}/INN.py
PATH_PYTHON_NNRPD_MODULE= ${PATHFILTER}/nnrpd.py
PATH_NNRPAUTH           = ${PATHFILTER}/nnrpd_auth.pl
PATH_NNRPYAUTH          = ${PATHFILTER}/nnrpd_auth.py
PATH_NNRPACCESS         = ${PATHFILTER}/nnrpd_access.pl
PATH_NNRPYACCESS        = ${PATHFILTER}/nnrpd_access.py
PATH_NNRPYDYNAMIC       = ${PATHFILTER}/nnrpd_dynamic.py

PATH_CONFIG		= ${PATHETC}/inn.conf
PATH_CONTROLCTL		= ${PATHETC}/control.ctl
PATH_CONTROLCTLLOCAL	= ${PATHETC}/control.ctl.local
PATH_EXPIRECTL		= ${PATHETC}/expire.ctl
PATH_INNDHOSTS		= ${PATHETC}/incoming.conf
PATH_MODERATORS		= ${PATHETC}/moderators
PATH_DISTPATS		= ${PATHETC}/distrib.pats
PATH_DISTRIBUTIONS	= ${PATHETC}/distributions
PATH_NEWSFEEDS		= ${PATHETC}/newsfeeds
PATH_READERSCONF	= ${PATHETC}/readers.conf
PATH_NNRPDTRACK		= ${PATHETC}/nnrpd.track
PATH_NNTPPASS		= ${PATHETC}/passwd.nntp
PATH_CTLWATCH		= ${PATHETC}/innwatch.ctl
PATH_ACTSYNC_IGN	= ${PATHETC}/actsync.ign
PATH_ACTSYNC_CFG	= ${PATHETC}/actsync.cfg
PATH_MOTD_INND		= ${PATHETC}/motd.innd.sample
PATH_MOTD_NNRPD		= ${PATHETC}/motd.nnrpd.sample
PATH_STORAGECONF	= ${PATHETC}/storage.conf
PATH_CYCBUFFCONFIG	= ${PATHETC}/cycbuff.conf
PATH_INNFEEDCTL		= ${PATHETC}/innfeed.conf
PATH_BUFFINDEXED	= ${PATHETC}/buffindexed.conf
PATH_RADIUS_CONF	= ${PATHETC}/inn-radius.conf
PATH_OVDB_CONF		= ${PATHETC}/ovdb.conf
PATH_OVSQLITE_CONF	= ${PATHETC}/ovsqlite.conf
PATH_SENDUUCP_CF	= ${PATHETC}/send-uucp.cf
PATH_SUBSCRIPTIONS	= ${PATHETC}/subscriptions
PATH_INNSECRETSCONF	= ${PATHETC}/inn-secrets.conf

PATH_ACTIVE		= ${PATHDB}/active
PATH_ACTIVE_TIMES	= ${PATHDB}/active.times
PATH_HISTORY		= ${PATHDB}/history
PATH_NEWSGROUPS		= ${PATHDB}/newsgroups

##  Scripts from above, plus site-specific config files.
REST		= \
	newsfeeds incoming.conf nnrpd.track passwd.nntp \
	inn.conf moderators innreport.conf innreport.css localgroups \
	control.ctl control.ctl.local expire.ctl nntpsend.ctl \
	innwatch.ctl distrib.pats distributions actsync.cfg actsync.ign \
	motd.innd motd.nnrpd storage.conf cycbuff.conf buffindexed.conf \
	innfeed.conf startup_innd.pl filter_innd.pl filter_nnrpd.pl \
	filter_innd.py INN.py \
	innshellvars.local innshellvars.pl.local innshellvars.tcl.local \
	nnrpd.py \
	nnrpd_auth.pl nnrpd_access.pl nocem.ctl \
        news2mail.cf readers.conf \
	inn-radius.conf nnrpd_auth.py nnrpd_access.py nnrpd_dynamic.py \
	ovdb.conf ovsqlite.conf active.minimal \
	newsgroups.minimal send-uucp.cf subscriptions inn-secrets.conf

ALL		= $(REST)

REST_INSTALLED	= \
	$D$(PATH_NEWSFEEDS) $D$(PATH_INNDHOSTS) \
	$D$(PATH_NNRPDTRACK) $D$(PATH_NNTPPASS) \
	$D$(PATH_CONFIG) $D$(PATH_MODERATORS) \
	$D$(PATH_CONTROLCTL) $D$(PATH_CONTROLCTLLOCAL) $D$(PATH_EXPIRECTL) \
	$D$(PATHETC)/nntpsend.ctl \
	$D$(PATHETC)/innreport.conf $D$(PATHHTTP)/innreport.css \
	$D$(PATHETC)/localgroups \
	$D$(PATH_CTLWATCH) $D$(PATH_DISTPATS) $D$(PATH_DISTRIBUTIONS) \
	$D$(PATH_ACTSYNC_CFG) $D$(PATH_ACTSYNC_IGN) \
	$D$(PATH_MOTD_INND) $D$(PATH_MOTD_NNRPD) $D$(PATH_STORAGECONF) \
	$D$(PATH_CYCBUFFCONFIG) $D$(PATH_BUFFINDEXED) \
	$D$(PATH_INNFEEDCTL) $D$(PATH_PERL_STARTUP_INND) \
	$D$(PATH_PERL_FILTER_INND) $D$(PATH_PERL_FILTER_NNRPD) \
	$D$(PATH_PYTHON_FILTER_INND) $D$(PATH_PYTHON_INN_MODULE) \
	$D$(PATH_PYTHON_NNRPD_MODULE) \
	$D$(PATH_TCL_STARTUP) $D$(PATH_TCL_FILTER) \
	$D$(PATHETC)/innshellvars.local $D$(PATHETC)/innshellvars.pl.local \
	$D$(PATHETC)/innshellvars.tcl.local \
	$D$(PATHETC)/nocem.ctl \
	$D$(PATH_NNRPAUTH) $D$(PATHETC)/news2mail.cf $D$(PATH_READERSCONF) \
	$D$(PATH_RADIUS_CONF) $D$(PATH_NNRPYAUTH) $D$(PATH_NNRPYACCESS) \
	$D$(PATH_NNRPYDYNAMIC) $D$(PATH_OVDB_CONF) $D$(PATH_OVSQLITE_CONF) \
	$D$(PATH_SENDUUCP_CF) $D$(PATH_SUBSCRIPTIONS) $D$(PATH_NNRPACCESS) \
	$D$(PATH_INNSECRETSCONF)

ALL_INSTALLED	= $(REST_INSTALLED)

SPECIAL		= $D$(PATH_ACTIVE) $D$(PATH_ACTIVE_TIMES) \
		$D$(PATH_NEWSGROUPS) $D$(PATH_HISTORY)

##  Get new versions of everything from samples directory.
all:		$(ALL) config

##  Show changes between files here and ones in samples.
diff:
	@$(MAKE) COPY=-${DIFF} all

##  Show changes between files here and installed versions.
diff-installed:
	@$(MAKE) COPY_RPRI=-${DIFF} COPY_RPUB=-${DIFF} COPY_XPRI=-${DIFF} COPY_XPUB=-${DIFF} COPY_WXPUB=-${DIFF} $(ALL_INSTALLED)

##  Show what would be copied from samples directory.
what:
	@$(MAKE) -s 'COPY=@echo' $(ALL) | ${AWK} 'NF==2 { print $$2; }'

config:		$(ALL)
	date >config

##  Don't use parallel rules -- we want this to be viewed carefully.
install:	all $(PAUSE) install-config $(RELOAD_AND_GO)
reload-install:	all pause    install-config reload go
install-config:		update $(REST_INSTALLED) $(SPECIAL)

##  Install scripts, not per-host config files.
update:		all
	@echo '' ; echo 'inn.conf in site directory may have newly added parameters'
	@echo 'which installed inn.conf does not have.  Check those parameters'
	@echo 'before you run innd.' ; echo ''
	date >update

##  Special rules for files that should never be overwritten if they are
##  already installed.  These are used only for the initial install of a
##  brand new server.
$D$(PATH_ACTIVE): 	; $(CP_DATA) active.minimal $@
$D$(PATH_NEWSGROUPS):	; $(CP_DATA) newsgroups.minimal $@
$D$(PATH_ACTIVE_TIMES):
	touch $@
	@ME=`$(WHOAMI)` ; \
	if [ x"$$ME" = xroot ] ; then \
	    chown $(RUNASUSER) $@ ; \
	    chgrp $(RUNASGROUP) $@ ; \
	fi
	chmod $(FILEMODE) $@
$D$(PATH_HISTORY):
	touch $@
	@ME=`$(WHOAMI)` ; \
	if [ x"$$ME" = xroot ] ; then \
	    chown $(RUNASUSER) $@ ; \
	    chgrp $(RUNASGROUP) $@ ; \
	fi
	chmod $(FILEMODE) $@
	@ME=`$(WHOAMI)` ; \
	if [ -z "$D" ] ; then \
	    if [ x"$$ME" = xroot ] || [ x"$$ME" = x"$(RUNASUSER)" ] ; then \
	        $(PATHBIN)/makedbz -i -o ; \
	    fi ; \
	fi

bootstrap:

##  Remove files that are unchanged from the release version.
clean:
	@-for I in $(ALL) ; do \
	    cmp -s $$I ../samples/$$I && echo rm -f $$I && rm -f $$I ; \
	done

clobber distclean maintclean:
	rm -f $(ALL) profiled config update

profiled:
	cp /dev/null profiled

depend:

##  Commands to make private or public, read or executable files.
COPY_RPRI	= $(CP_RPRI)
COPY_RPUB	= $(CP_RPUB)
COPY_XPRI	= $(CP_XPRI)
COPY_XPUB	= $(CP_XPUB)
COPY_WXPUB	= $(CP_WXPUB)

##  Files to copy.
$D$(PATH_INNDHOSTS):	incoming.conf	; $(COPY_RPRI) $? $@
$D$(PATH_NEWSFEEDS):	newsfeeds	; $(COPY_RPUB) $? $@
$D$(PATH_READERSCONF):	readers.conf	; $(COPY_RPUB) $? $@
$D$(PATH_RADIUS_CONF):	inn-radius.conf	; $(COPY_RPRI) $? $@
$D$(PATH_NNRPDTRACK):	nnrpd.track	; $(COPY_RPUB) $? $@
$D$(PATH_CONTROLCTL):	control.ctl	; $(COPY_RPUB) $? $@
$D$(PATH_CONTROLCTLLOCAL): control.ctl.local	; $(COPY_RPUB) $? $@
$D$(PATH_CTLWATCH):	innwatch.ctl	; $(COPY_RPUB) $? $@
$D$(PATH_EXPIRECTL):	expire.ctl	; $(COPY_RPUB) $? $@
$D$(PATH_CONFIG):	inn.conf	; $(COPY_RPUB) $? $@
$D$(PATH_MODERATORS):	moderators	; $(COPY_RPUB) $? $@
$D$(PATH_DISTPATS):	distrib.pats	; $(COPY_RPUB) $? $@
$D$(PATH_DISTRIBUTIONS): distributions  ; $(COPY_RPUB) $? $@
$D$(PATH_NNTPPASS):	passwd.nntp	; $(COPY_RPRI) $? $@
$D$(PATHETC)/nntpsend.ctl: nntpsend.ctl	; $(COPY_RPUB) $? $@
$D$(PATHETC)/news2mail.cf: news2mail.cf	; $(COPY_RPUB) $? $@
$D$(PATHETC)/innreport.conf: innreport.conf	; $(COPY_RPUB) $? $@
$D$(PATHHTTP)/innreport.css: innreport.css	; $(COPY_RPUB) $? $@
$D$(PATHETC)/innshellvars.local: innshellvars.local	; $(COPY_WXPUB) $? $@
$D$(PATHETC)/innshellvars.pl.local: innshellvars.pl.local	; $(COPY_WXPUB) $? $@
$D$(PATHETC)/innshellvars.tcl.local: innshellvars.tcl.local	; $(COPY_WXPUB) $? $@
$D$(PATHETC)/localgroups: localgroups	; $(COPY_RPUB) $? $@
$D$(PATH_STORAGECONF): storage.conf	; $(COPY_RPUB) $? $@
$D$(PATH_CYCBUFFCONFIG): cycbuff.conf	; $(COPY_RPUB) $? $@
$D$(PATH_BUFFINDEXED): buffindexed.conf	; $(COPY_RPUB) $? $@
$D$(PATH_OVDB_CONF): ovdb.conf		; $(COPY_RPUB) $? $@
$D$(PATH_OVSQLITE_CONF): ovsqlite.conf	; $(COPY_RPUB) $? $@
$D$(PATH_PERL_STARTUP_INND): startup_innd.pl ; $(COPY_RPUB) $? $@
$D$(PATH_PERL_FILTER_INND): filter_innd.pl ; $(COPY_RPUB) $? $@
$D$(PATH_PERL_FILTER_NNRPD): filter_nnrpd.pl ; $(COPY_RPUB) $? $@
$D$(PATH_PYTHON_FILTER_INND): filter_innd.py ; $(COPY_RPUB) $? $@
$D$(PATH_PYTHON_INN_MODULE): INN.py ;	$(COPY_RPUB) $? $@
$D$(PATH_PYTHON_NNRPD_MODULE): nnrpd.py ;   $(COPY_RPUB) $? $@
$D$(PATH_NNRPAUTH): nnrpd_auth.pl       ; $(COPY_RPUB) $? $@
$D$(PATH_NNRPACCESS): nnrpd_access.pl   ; $(COPY_RPUB) $? $@
$D$(PATH_NNRPYAUTH): nnrpd_auth.py      ; $(COPY_RPUB) $? $@
$D$(PATH_NNRPYACCESS): nnrpd_access.py  ; $(COPY_RPUB) $? $@
$D$(PATH_NNRPYDYNAMIC): nnrpd_dynamic.py     ; $(COPY_RPUB) $? $@
$D$(PATHETC)/nocem.ctl: nocem.ctl       ; $(COPY_RPUB) $? $@
$D$(PATH_ACTSYNC_CFG): actsync.cfg	; $(COPY_RPUB) $? $@
$D$(PATH_ACTSYNC_IGN): actsync.ign	; $(COPY_RPUB) $? $@
$D$(PATH_MOTD_INND): motd.innd		; $(COPY_RPUB) $? $@
$D$(PATH_MOTD_NNRPD): motd.nnrpd	; $(COPY_RPUB) $? $@
$D$(PATH_INNFEEDCTL): innfeed.conf	; $(COPY_RPRI) $? $@
$D$(PATH_SENDUUCP_CF): send-uucp.cf	; $(COPY_RPUB) $? $@
$D$(PATH_SUBSCRIPTIONS): subscriptions	; $(COPY_RPUB) $? $@
$D$(PATH_INNSECRETSCONF): inn-secrets.conf   ; $(COPY_RPRI) $? $@

REASON	= 'Installing site config files from site/Makefile'
go pause:
	-${CTLINND} $@ $(REASON)
reload:
	-${CTLINND} reload all $(REASON)

##  Use this to just replace any changed files you might have made.  Only
##  do this after you've examined the output of "make -n"!
replace:
	$(MAKE) COPY=cp all

##  Get files from the samples directory.
COPY	= $(SHELL) ./getsafe.sh
actsync.cfg:	../samples/actsync.cfg		; $(COPY) $? $@
actsync.ign:	../samples/actsync.ign		; $(COPY) $? $@
control.ctl:	../samples/control.ctl		; $(COPY) $? $@
control.ctl.local: ../samples/control.ctl.local	; $(COPY) $? $@
expire.ctl:	../samples/expire.ctl		; $(COPY) $? $@
nnrpd_auth.pl:  ../samples/nnrpd_auth.pl	; $(COPY) $? $@
nnrpd_access.pl:  ../samples/nnrpd_access.pl	; $(COPY) $? $@
nnrpd_auth.py:  ../samples/nnrpd_auth.py	; $(COPY) $? $@
nnrpd_access.py: ../samples/nnrpd_access.py     ; $(COPY) $? $@
nnrpd_dynamic.py: ../samples/nnrpd_dynamic.py   ; $(COPY) $? $@
filter_innd.pl:	../samples/filter_innd.pl	; $(COPY) $? $@
filter_nnrpd.pl: ../samples/filter_nnrpd.pl	; $(COPY) $? $@
filter_innd.py:	../samples/filter_innd.py	; $(COPY) $? $@
INN.py:		../samples/INN.py		; $(COPY) $? $@
nnrpd.py:       ../samples/nnrpd.py             ; $(COPY) $? $@
incoming.conf:	../samples/incoming.conf	; $(COPY) $? $@
inn.conf:	../samples/inn.conf		; $(COPY) $? $@
innreport.conf:	../samples/innreport.conf	; $(COPY) $? $@
innreport.css:	../samples/innreport.css	; $(COPY) $? $@
innshellvars.local: ../samples/innshellvars.local	; $(COPY) $? $@
innshellvars.pl.local: ../samples/innshellvars.pl.local	; $(COPY) $? $@
innshellvars.tcl.local: ../samples/innshellvars.tcl.local	; $(COPY) $? $@
localgroups:	../samples/localgroups		; $(COPY) $? $@
storage.conf:	../samples/storage.conf		; $(COPY) $? $@
cycbuff.conf:	../samples/cycbuff.conf		; $(COPY) $? $@
buffindexed.conf: ../samples/buffindexed.conf	; $(COPY) $? $@
ovdb.conf:	../samples/ovdb.conf		; $(COPY) $? $@
ovsqlite.conf:	../samples/ovsqlite.conf	; $(COPY) $? $@
innwatch.ctl:	../samples/innwatch.ctl		; $(COPY) $? $@
innfeed.conf:	../samples/innfeed.conf		; $(COPY) $? $@
moderators:	../samples/moderators		; $(COPY) $? $@
distrib.pats:	../samples/distrib.pats		; $(COPY) $? $@
distributions:	../samples/distributions	; $(COPY) $? $@
motd.innd:	../samples/motd.innd		; $(COPY) $? $@
motd.nnrpd:	../samples/motd.nnrpd		; $(COPY) $? $@

=== storage/Makefile ===
include ../Makefile.global

# This version number should be increased with every change to the library
# source following the rules laid out in the libtool manual.  This will also
# force the file name of the shared library to change so that one can
# recover from make update.  We can't use .OLD extensions for the shared
# library since ldconfig will think .OLD sorts after the regular library and
# will point the binaries at the old library.
LTVERSION     = 4:1:1

top	      = ..
CFLAGS	      = $(GCFLAGS) -I. $(BDB_CPPFLAGS) $(SQLITE3_CPPFLAGS)

SOURCES	      = expire.c interface.c methods.c ov.c overdata.c overview.c \
		ovmethods.c $(METHOD_SOURCES)
OBJECTS	      = $(SOURCES:.c=.o)
LOBJECTS      = $(OBJECTS:.o=.lo)

.SUFFIXES: .lo

all: library programs

$(FIXSCRIPT):
	@echo Run configure before running make.  See INSTALL for details.
	@exit 1

FIX	= $(SHELL) $(FIXSCRIPT)

# Included here after the FIX definition and all target, since additional rules
# are defined in Make.methods.  Be sure that we recurse properly to build the
# methods.
include Make.methods

warnings:
	$(MAKE) COPT="$(COPT) $(WARNINGS)" all

install: all
	$(LI_LPUB) libinnstorage.$(EXTLIB) $D$(PATHLIB)/libinnstorage.$(EXTLIB)
	for F in $(PROGRAMS) ; do \
	    $(LI_XPRI) $$F $D$(PATHBIN)/`basename $$F` ; \
	done

bootstrap: Make.methods

library: libinnstorage.$(EXTLIB)

programs: $(PROGRAMS)

clean:
	rm -f *.o *.lo */*.o */*.lo libinnstorage.la libinnstorage.a
	rm -f $(PROGRAMS) libinnstorage_pure_*.a .pure
	rm -f buildconfig libinnstorage$(PROFSUFFIX).a
	rm -rf .libs */.libs
	rm -f $(RM_CLEAN)

clobber distclean: clean
	rm -f $(RM_DISTCLEAN)

maintclean: distclean
	rm -f Make.methods methods.c methods.h ovmethods.c ovmethods.h
	rm -f $(RM_MAINTCLEAN)

libinnstorage.la: $(OBJECTS) $(LOBJECTS) $(LIBINN)
	$(LIBLD) $(LDFLAGS) -o $@ $(LOBJECTS) \
	    $(LIBINN) $(STORAGE_LIBS) $(LIBS) \
	    -rpath $(PATHLIB) -version-info $(LTVERSION)

libinnstorage.a: $(OBJECTS)
	ar r $@ $(OBJECTS)
	$(RANLIB) libinnstorage.a

# Make.methods is included in the distribution tarball since some non-GNU
# makes can't deal with including a non-existent file, so don't depend on
# it.  The dependencies aren't entirely accurate; you really want to re-run
# buildconfig each time a new subdirectory is added to the directory.  But
# adding a dependency on . is a bit too non-portable for my taste and causes
# too many rebuilds.
Make.methods methods.h ovmethods.c ovmethods.h methods.c: buildconfig
	./buildconfig

buildconfig: buildconfig.in $(FIXSCRIPT)
	$(FIX) -i buildconfig.in

.c.o .c.lo:
	$(LIBCC) $(CFLAGS) $(CCOUTPUT)

ovtest:	ov.c libinnstorage.$(EXTLIB) $(LIBINN)
	$(CC) $(CFLAGS) -D_TEST_ -o ovtest ov.c \
	    libinnstorage.$(EXTLIB) $(LIBINN) $(STORAGE_LIBS) $(LIBS)

$(LIBINN):      ; (cd ../lib ; $(MAKE))
$(LIBHIST):	; (cd ../history ; $(MAKE))


##  Profiling.  The rules are a bit brute-force, but good enough.

profiled: libinnstorage$(PROFSUFFIX).a

libinnstorage$(PROFSUFFIX).a: $(SOURCES)
	rm -f $(OBJECTS)
	$(MAKEPROFILING) libinnstorage.a
	mv libinnstorage.a libinnstorage$(PROFSUFFIX).a
	$(RANLIB) libinnstorage$(PROFSUFFIX).a
	rm -f $(OBJECTS)


# TODO bodge in missing dependency.  This isn't a full solution
# but it works for now.
#
# See https://github.com/InterNetNews/inn/issues/206
ovsqlite/ovsqlite-server.lo: ovsqlite/sql-init.h

##  Dependencies.  Default list, below, is probably good enough.

depend:	Makefile $(SOURCES) $(EXTRA_SOURCES)
	$(MAKEDEPEND) '$(CFLAGS)' $(SOURCES) $(EXTRA_SOURCES)

# DO NOT DELETE THIS LINE -- make depend depends on it.
expire.o: expire.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h ../include/inn/ov.h \
  ../include/inn/history.h ../include/inn/storage.h \
  ../include/inn/options.h ../include/inn/overview.h \
  ../include/inn/paths.h ../include/inn/vector.h ovinterface.h
interface.o: interface.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/conffile.h \
  ../include/portable/macros.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/paths.h ../include/inn/wire.h \
  interface.h ../include/inn/storage.h ../include/inn/options.h methods.h
methods.o: methods.c interface.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/inn/storage.h \
  ../include/inn/macros.h ../include/inn/options.h \
  ../include/inn/portable-stdbool.h methods.h cnfs/cnfs.h \
  timecaf/timecaf.h interface.h timehash/timehash.h tradspool/tradspool.h \
  trash/trash.h
ov.o: ov.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/vector.h ../include/inn/wire.h ovinterface.h ovmethods.h
overdata.o: overdata.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/buffer.h \
  ../include/inn/portable-stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/overview.h \
  ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/vector.h ../include/inn/wire.h ovinterface.h \
  ../include/inn/history.h ../include/inn/ov.h
overview.o: overview.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/inn/buffer.h \
  ../include/inn/portable-stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/storage.h ../include/inn/options.h \
  ../include/inn/overview.h ../include/inn/vector.h ../include/inn/wire.h \
  ovinterface.h ovmethods.h
ovmethods.o: ovmethods.c ovinterface.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/inn/history.h \
  ../include/inn/macros.h ../include/inn/portable-stdbool.h \
  ../include/inn/ov.h ../include/inn/storage.h ../include/inn/options.h \
  ovmethods.h buffindexed/buffindexed.h ovdb/ovdb.h ovsqlite/ovsqlite.h \
  tradindexed/tradindexed.h
buffindexed/buffindexed.o: buffindexed/buffindexed.c ../include/portable/system.h \
  ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/macros.h ../include/portable/stdbool.h \
  ../include/portable/mmap.h ../include/inn/fdflag.h \
  ../include/inn/portable-socket.h ../include/inn/system.h \
  ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/portable-stdbool.h \
  ../include/inn/innconf.h ../include/inn/macros.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/ov.h ../include/inn/history.h \
  ../include/inn/storage.h ../include/inn/options.h ../include/inn/paths.h \
  ovinterface.h buffindexed/shmem.h buffindexed/buffindexed.h
buffindexed/shmem.o: buffindexed/shmem.c ../include/portable/system.h \
  ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/macros.h ../include/portable/stdbool.h \
  ../include/inn/libinn.h ../include/inn/concat.h ../include/inn/macros.h \
  ../include/inn/portable-stdbool.h ../include/inn/xmalloc.h \
  ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h buffindexed/shmem.h
cnfs/cnfs.o: cnfs/cnfs.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/portable/mmap.h \
  ../include/inn/fdflag.h ../include/inn/portable-socket.h \
  ../include/inn/system.h ../include/inn/portable-getaddrinfo.h \
  ../include/inn/portable-getnameinfo.h ../include/inn/portable-stdbool.h \
  ../include/inn/innconf.h ../include/inn/macros.h ../include/inn/libinn.h \
  ../include/inn/concat.h ../include/inn/xmalloc.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/mmap.h ../include/inn/paths.h \
  ../include/inn/wire.h interface.h ../include/inn/storage.h \
  ../include/inn/options.h methods.h interface.h cnfs/cnfs-private.h \
  cnfs/cnfs.h
ovdb/ovdb.o: ovdb/ovdb.c ../include/portable/system.h ../include/config.h \
  ../include/inn/macros.h ../include/inn/portable-macros.h \
  ../include/inn/options.h ../include/inn/system.h \
  ../include/portable/stdbool.h ../include/portable/macros.h \
  ../include/portable/stdbool.h ../include/portable/socket.h \
  ../include/portable/getaddrinfo.h ../include/portable/getnameinfo.h \
  ../include/conffile.h ../include/portable/macros.h \
  ../include/inn/fdflag.h ../include/inn/portable-socket.h \
  ../include/inn/portable-stdbool.h ../include/inn/innconf.h \
  ../include/inn/macros.h ../include/inn/libinn.h ../include/inn/concat.h \
  ../include/inn/xmalloc.h ../include/inn/system.h ../include/inn/xwrite.h \
  ../include/inn/messages.h ../include/inn/newsuser.h \
  ../include/inn/paths.h ../include/inn/storage.h ../include/inn/options.h \
  ../include/portable/socket-unix.h ../include/inn/ov.h \
  ../include/inn/history.h ovdb/ovdb-private.h ovdb/ovdb.h ovinterface.h
ovsqlite/ovsqlite-private.o: ovsqlite/ovsqlite-private.c \
  ovsqlite/ovsqlite-private.h ../include/portable/system.h \
  ../include/config.h ../include/inn/macros.h \
  ../include/inn/portable-macros.h ../include/inn/options.h \
  ../include/inn/system.h ../include/portable/stdbool.h \
  ../include/portable/macros.h ../include/portable/stdbool.h \
  ../include/inn/buffer.h ../include/inn/portable-stdbool.h \
  ../include/inn/xmalloc.h ../include/inn/system.h
ovsqlite/ovsqlite.o: ovsqlite/ovsqlite.c ovsqlite/ovsqlite.h ../include/config.h \

=== tests/Makefile ===
include ../Makefile.global

top		= ..
RUNTESTS_CFLAGS	= -DC_TAP_SOURCE='"$(abs_builddir)/tests"' -DC_TAP_BUILD='"$(abs_builddir)/tests"'
CFLAGS		= $(GCFLAGS) $(BDB_CPPFLAGS) $(CANLOCK_CPPFLAGS) \
		  $(DBM_CPPFLAGS) $(SQLITE3_CPPFLAGS) $(PERL_CPPFLAGS) \
		  $(PYTHON_CPPFLAGS) $(SSL_CPPFLAGS) $(SASL_CPPFLAGS) \
		  $(KRB5_CPPFLAGS) $(RUNTESTS_CFLAGS) -I.

##  On some platforms, linking with libm is needed as the test suite uses
##  math functions (currently only lib/confparse-t.c).
LIBM_LDFLAGS    = '-lm'

##  The tests that need to be built.  Tests in the form of shell scripts
##  or some other form that doesn't require compiling shouldn't be in this
##  list.  If they need other things compiled, those other things should be
##  added to EXTRA.

TESTS	= authprogs/ident.t innd/artparse.t innd/chan.t lib/artnumber.t \
	lib/asprintf.t lib/buffer.t lib/canlock.t lib/concat.t lib/conffile.t \
	lib/confparse.t lib/daemon.t lib/date.t \
	lib/dispatch.t lib/fdflag.t \
	lib/getaddrinfo.t lib/getnameinfo.t lib/hash.t \
	lib/hashtab.t lib/headers.t lib/hex.t lib/inet_aton.t \
	lib/inet_ntoa.t lib/inet_ntop.t lib/innconf.t lib/list.t lib/md5.t \
	lib/messageid.t lib/messages.t lib/mkstemp.t \
	lib/network/addr-ipv4.t lib/network/addr-ipv6.t \
	lib/network/client.t lib/network/server.t \
	lib/pread.t lib/pwrite.t lib/qio.t lib/reallocarray.t \
	lib/setenv.t lib/snprintf.t lib/strlcat.t \
	lib/strlcpy.t lib/tst.t lib/uwildmat.t lib/vector.t lib/wire.t \
	lib/xwrite.t nnrpd/auth-ext.t overview/api.t overview/buffindexed.t \
	overview/tradindexed.t overview/xref.t util/innbind.t

##  Extra stuff that needs to be built before tests can be run.

EXTRA	= runtests clients/server-list docs/pod.t lib/xmalloc

all check test tests: $(TESTS) $(EXTRA)
	./runtests -l TESTS

build: $(TESTS) $(EXTRA)

warnings:
	$(MAKE) COPT="$(COPT) $(WARNINGS)" build

clean clobber distclean maintclean:
	rm -f *.o *.lo */*.o */*.lo */*/*.o */*/*.o \
	  .pure */.pure */*/.pure $(TESTS) $(EXTRA)
	rm -rf .libs */.libs */*/.libs

$(FIXSCRIPT):
	@echo Run configure before running make.  See INSTALL for details.
	@exit 1

FIX	= $(SHELL) $(FIXSCRIPT)
.c.o:
	$(CC) $(CFLAGS) -c -o $@ $*.c

LINK		= $(LIBLD) $(LDFLAGS) $(BDB_LDFLAGS) $(CANLOCK_LDFLAGS) \
		  $(SSL_LDFLAGS) $(SASL_LDFLAGS) $(KRB5_LDFLAGS) -o $@
LINKDEPS	= $(LIBLDDEPS) $(LDFLAGS) $(BDB_LDFLAGS) $(CANLOCK_LDFLAGS) \
		  $(SSL_LDFLAGS) $(SASL_LDFLAGS) $(KRB5_LDFLAGS) -o $@
STORAGEDEPS	= $(LIBSTORAGE) $(LIBHIST) $(LIBINN)
STORAGELIBS	= $(STORAGEDEPS) $(STORAGE_LIBS)

# All of the innd object files other than innd.o, for INN unit testing.
INNOBJS		= ../innd/art.o ../innd/cc.o ../innd/chan.o ../innd/icd.o \
		../innd/keywords.o ../innd/lc.o ../innd/nc.o \
		../innd/newsfeeds.o ../innd/ng.o ../innd/perl.o \
		../innd/proc.o ../innd/python.o ../innd/rc.o ../innd/site.o \
		../innd/status.o ../innd/util.o ../innd/wip.o

# The libraries innd needs to link.
INNDLIBS        = $(LIBSTORAGE) $(LIBHIST) $(LIBINN) $(STORAGE_LIBS) \
		  $(SYSTEMD_LIBS) $(CANLOCK_LIBS) \
		  $(PYTHON_LIBS) $(REGEX_LIBS) $(LIBS) $(PERL_LIBS)

runtests: runtests.o
	$(LINK) runtests.o

clients/server-list: clients/server-list.in $(FIXSCRIPT)
	$(FIX) -i clients/server-list.in

docs/pod.t: docs/pod.t.in $(FIXSCRIPT)
	$(FIX) -i docs/pod.t.in

authprogs/ident.t: authprogs/ident-t.o tap/basic.o $(LIBINN)
	$(LINK) authprogs/ident-t.o tap/basic.o $(LIBINN) $(LIBS)

innd/artparse.t: innd/artparse-t.o innd/fakeinnd.o tap/basic.o $(INNOBJS)
	$(LINK) innd/artparse-t.o innd/fakeinnd.o tap/basic.o $(INNOBJS) \
	    $(INNDLIBS)

innd/chan.t: innd/chan-t.o innd/fakeinnd.o tap/basic.o $(INNOBJS)
	$(LINK) innd/chan-t.o innd/fakeinnd.o tap/basic.o $(INNOBJS) $(INNDLIBS)

lib/artnumber.t: lib/artnumber-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/artnumber-t.o tap/basic.o $(LIBINN)

lib/asprintf.o: ../lib/asprintf.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/asprintf.c

lib/asprintf.t: lib/asprintf.o lib/asprintf-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/asprintf.o lib/asprintf-t.o tap/basic.o $(LIBINN) $(LIBS)

lib/buffer.t: lib/buffer-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/buffer-t.o tap/basic.o $(LIBINN)

lib/canlock.t: lib/canlock-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/canlock-t.o tap/basic.o $(LIBINN) $(CANLOCK_LIBS)

lib/concat.t: lib/concat-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/concat-t.o tap/basic.o $(LIBINN)

lib/conffile.t: lib/conffile-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/conffile-t.o tap/basic.o $(LIBINN)

lib/confparse.t: lib/confparse-t.o tap/basic.o tap/float.o tap/messages.o tap/string.o $(LIBINN)
	$(LINK) $(LIBM_LDFLAGS) lib/confparse-t.o tap/basic.o tap/float.o \
	    tap/messages.o tap/string.o $(LIBINN)

lib/daemon.o: ../lib/daemon.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/daemon.c

lib/daemon.t: lib/daemon.o lib/daemon-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/daemon.o lib/daemon-t.o tap/basic.o $(LIBINN) $(LIBS)

lib/date.t: lib/date-t.o tap/basic.o tap/string.o $(LIBINN)
	$(LINK) lib/date-t.o tap/basic.o tap/string.o $(LIBINN)

lib/dispatch.t: lib/dispatch-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/dispatch-t.o tap/basic.o $(LIBINN)

lib/fdflag.t: lib/fdflag-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/fdflag-t.o tap/basic.o $(LIBINN) $(LIBS)

lib/getaddrinfo.o: ../lib/getaddrinfo.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/getaddrinfo.c

lib/getaddrinfo.t: lib/getaddrinfo.o lib/getaddrinfo-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/getaddrinfo.o lib/getaddrinfo-t.o tap/basic.o \
	    $(LIBINN) $(LIBS)

lib/getnameinfo.o: ../lib/getnameinfo.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/getnameinfo.c

lib/getnameinfo.t: lib/getnameinfo.o lib/getnameinfo-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/getnameinfo.o lib/getnameinfo-t.o tap/basic.o \
	    $(LIBINN) $(LIBS)

lib/hash.t: lib/hash-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/hash-t.o tap/basic.o $(LIBINN)

lib/hashtab.t: lib/hashtab-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/hashtab-t.o tap/basic.o $(LIBINN)

lib/headers.t: lib/headers-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/headers-t.o tap/basic.o $(LIBINN)

lib/hex.t: lib/hex-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/hex-t.o tap/basic.o $(LIBINN) $(LIBS)

lib/inet_aton.o: ../lib/inet_aton.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/inet_aton.c

lib/inet_aton.t: lib/inet_aton.o lib/inet_aton-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/inet_aton.o lib/inet_aton-t.o tap/basic.o $(LIBINN)

lib/inet_ntoa.o: ../lib/inet_ntoa.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/inet_ntoa.c

lib/inet_ntoa.t: lib/inet_ntoa.o lib/inet_ntoa-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/inet_ntoa.o lib/inet_ntoa-t.o tap/basic.o $(LIBINN)

lib/inet_ntop.o: ../lib/inet_ntop.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/inet_ntop.c

lib/inet_ntop.t: lib/inet_ntop.o lib/inet_ntop-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/inet_ntop.o lib/inet_ntop-t.o tap/basic.o $(LIBINN)

lib/innconf.t: lib/innconf-t.o tap/basic.o tap/messages.o tap/string.o $(LIBINN)
	$(LINK) lib/innconf-t.o tap/basic.o tap/messages.o \
	    tap/string.o $(LIBINN) $(LIBS)

lib/list.t: lib/list-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/list-t.o tap/basic.o $(LIBINN) $(LIBS)

lib/md5.t: lib/md5-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/md5-t.o tap/basic.o $(LIBINN)

lib/messageid.t: lib/messageid-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/messageid-t.o tap/basic.o $(LIBINN)

lib/messages.t: lib/messages-t.o tap/basic.o tap/process.o tap/string.o $(LIBINN)
	$(LINK) lib/messages-t.o tap/basic.o tap/process.o tap/string.o \
	    $(LIBINN)

lib/mkstemp.o: ../lib/mkstemp.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/mkstemp.c

lib/mkstemp.t: lib/mkstemp.o lib/mkstemp-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/mkstemp.o lib/mkstemp-t.o tap/basic.o $(LIBINN)

lib/network/addr-ipv4.t: lib/network/addr-ipv4-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/network/addr-ipv4-t.o tap/basic.o $(LIBINN) $(LIBS)

lib/network/addr-ipv6.t: lib/network/addr-ipv6-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/network/addr-ipv6-t.o tap/basic.o $(LIBINN) $(LIBS)

lib/network/client.t: lib/network/client-t.o tap/basic.o tap/messages.o tap/string.o $(LIBINN)
	$(LINK) lib/network/client-t.o tap/basic.o tap/messages.o \
	    tap/string.o $(LIBINN) $(LIBS)

lib/network/server.t: lib/network/server-t.o tap/basic.o tap/messages.o tap/string.o $(LIBINN)
	$(LINK) lib/network/server-t.o tap/basic.o tap/messages.o \
	    tap/string.o $(LIBINN) $(LIBS)

lib/pread.o: ../lib/pread.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/pread.c

lib/pread.t: lib/pread.o lib/pread-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/pread.o lib/pread-t.o tap/basic.o $(LIBINN)

lib/pwrite.o: ../lib/pwrite.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/pwrite.c

lib/pwrite.t: lib/pwrite.o lib/pwrite-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/pwrite.o lib/pwrite-t.o tap/basic.o $(LIBINN)

lib/qio.t: lib/qio-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/qio-t.o tap/basic.o $(LIBINN)

lib/reallocarray.o: ../lib/reallocarray.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/reallocarray.c

lib/reallocarray.t: lib/reallocarray.o lib/reallocarray-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/reallocarray.o lib/reallocarray-t.o tap/basic.o $(LIBINN)

lib/setenv.o: ../lib/setenv.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/setenv.c

lib/setenv.t: lib/setenv.o lib/setenv-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/setenv.o lib/setenv-t.o tap/basic.o $(LIBINN)

lib/snprintf.o: ../lib/snprintf.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/snprintf.c

lib/snprintf.t: lib/snprintf.o lib/snprintf-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/snprintf.o lib/snprintf-t.o tap/basic.o $(LIBINN)

lib/strlcat.o: ../lib/strlcat.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/strlcat.c

lib/strlcat.t: lib/strlcat.o lib/strlcat-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/strlcat.o lib/strlcat-t.o tap/basic.o $(LIBINN)

lib/strlcpy.o: ../lib/strlcpy.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/strlcpy.c

lib/strlcpy.t: lib/strlcpy.o lib/strlcpy-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/strlcpy.o lib/strlcpy-t.o tap/basic.o $(LIBINN)

lib/tst.t: lib/tst-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/tst-t.o tap/basic.o $(LIBINN)

lib/uwildmat.t: lib/uwildmat-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/uwildmat-t.o tap/basic.o $(LIBINN)

lib/vector.t: lib/vector-t.o tap/basic.o tap/string.o $(LIBINN)
	$(LINK) lib/vector-t.o tap/basic.o tap/string.o $(LIBINN)

lib/wire.t: lib/wire-t.o tap/basic.o $(LIBINN)
	$(LINK) lib/wire-t.o tap/basic.o $(LIBINN)

lib/xmalloc: lib/xmalloc.o $(LIBINN)
	$(LINK) lib/xmalloc.o $(LIBINN)

lib/xwrite.o: ../lib/xwrite.c
	$(CC) $(CFLAGS) -DTESTING -c -o $@ ../lib/xwrite.c

lib/xwrite.t: lib/xwrite-t.o lib/xwrite.o lib/fakewrite.o tap/basic.o $(LIBINN)
	$(LINK) lib/xwrite-t.o lib/xwrite.o lib/fakewrite.o tap/basic.o \
	    $(LIBINN)

nnrpd/auth-ext.t: nnrpd/auth-ext-t.o ../nnrpd/auth-ext.o tap/basic.o tap/messages.o tap/string.o $(LIBINN)
	$(LINK) nnrpd/auth-ext-t.o ../nnrpd/auth-ext.o tap/basic.o \
	    tap/messages.o tap/string.o $(LIBINN)

overview/api.t: overview/api-t.o tap/basic.o $(STORAGEDEPS)
	$(LINKDEPS) overview/api-t.o tap/basic.o $(STORAGELIBS) $(LIBS)

overview/buffindexed-t.o: overview/overview-t.c
	$(CC) $(CFLAGS) -DOVTYPE=buffindexed -c -o $@ overview/overview-t.c

overview/buffindexed.t: overview/buffindexed-t.o tap/basic.o $(STORAGEDEPS)
	$(LINKDEPS) overview/buffindexed-t.o tap/basic.o $(STORAGELIBS) $(LIBS)

overview/tradindexed-t.o: overview/overview-t.c
	$(CC) $(CFLAGS) -DOVTYPE=tradindexed -c -o $@ overview/overview-t.c

overview/tradindexed.t: overview/tradindexed-t.o tap/basic.o $(STORAGEDEPS)
	$(LINKDEPS) overview/tradindexed-t.o tap/basic.o $(STORAGELIBS) $(LIBS)

overview/xref.t: overview/xref-t.o tap/basic.o $(STORAGEDEPS)
	$(LINKDEPS) overview/xref-t.o tap/basic.o $(STORAGELIBS) $(LIBS)

util/innbind.t: util/innbind-t.o tap/basic.o $(LIBINN)
	$(LINK) util/innbind-t.o tap/basic.o $(LIBINN) $(LIBS)

=== doc/man/Makefile ===
include ../../Makefile.global

top	= ../..

SEC1	= convdate.1 delayer.1 fastrm.1 gencancel.1 getlist.1 \
	grephistory.1 inews.1 \
	innconfval.1 innmail.1 nntpget.1 pgpverify.1 pullnews.1 rnews.1 \
	shlock.1 shrinkfile.1 simpleftp.1 sm.1

SEC3	= libinn.3 libinn_clientlib.3 libinn_dbz.3 libinn_inndcomm.3 \
	libinn_list.3 libinn_qio.3 libinn_tst.3 libinn_uwildmat.3 \
	libinnauth.3 libinnhist.3 libinnstorage.3

SEC3PM	= INN__Config.3pm \
	INN__Utils__Shlock.3pm INN__ovsqlite_client.3pm

SEC5	= active.5 active.times.5 buffindexed.conf.5 control.ctl.5 \
	cycbuff.conf.5 distrib.pats.5 distributions.5 expire.ctl.5 \
	history.5 incoming.conf.5 \
	inn.conf.5 innfeed.conf.5 innreport.conf.5 inn-secrets.conf.5 \
	innwatch.ctl.5 moderators.5 motd.news.5 \
	newsfeeds.5 newsgroups.5 newslog.5 nnrpd.track.5 nntpsend.ctl.5 ovdb.5 \
	ovsqlite.5 passwd.nntp.5 inn-radius.conf.5 readers.conf.5 \
	storage.conf.5 subscriptions.5

SEC8	= actsync.8 archive.8 batcher.8 buffchan.8 ckpasswd.8 \
	cnfsheadconf.8 cnfsstat.8 controlchan.8 ctlinnd.8 cvtbatch.8 \
	docheckgroups.8 domain.8 expire.8 expireover.8 expirerm.8 \
	ident.8 \
	innbind.8 inncheck.8 innd.8 inndf.8 innfeed.8 innreport.8 innstat.8 \
	innupgrade.8 innwatch.8 innxbatch.8 innxmit.8 mailpost.8 makedbz.8 \
	makehistory.8 mod-active.8 news.daily.8 news2mail.8 ninpaths.8 \
	nnrpd.8 nntpsend.8 ovdb_init.8 ovdb_monitor.8 ovdb_server.8 \
	ovdb_stat.8 overchan.8 ovsqlite-server.8 ovsqlite-util.8 perl-nocem.8 \
	procbatch.8 prunehistory.8 radius.8 rc.news.8 \
	scanlogs.8 scanspool.8 send-ihave.8 send-uucp.8 sendinpaths.8 \
	tally.control.8 tdx-util.8 tinyleaf.8 writelog.8

all:
clobber clean distclean:
profiled:

install: install-man1 install-man3 install-man3pm install-man5 install-man8

install-man1:
	for M in $(SEC1) ; do \
	    $(CP_MAN) $$M $D$(MAN1)/$$M ; \
	done

install-man3:
	for M in $(SEC3) ; do \
	    $(CP_MAN) $$M $D$(MAN3)/$$M ; \
	done

install-man3pm:
	$(CP_MAN) INN__Config.3pm $D$(MAN3PM)/INN\:\:Config.$(MAN3PM_EXT)
	$(CP_MAN) INN__Utils__Shlock.3pm $D$(MAN3PM)/INN\:\:Utils\:\:Shlock.$(MAN3PM_EXT)
	$(CP_MAN) INN__ovsqlite_client.3pm $D$(MAN3PM)/INN\:\:ovsqlite_client.$(MAN3PM_EXT)

# We also create symbolic links between config files and programs.
# We try to use relative symbolic links, when possible.  As '-ef' is
# not required by POSIX, we make absolute symbolic links before this
# test, in case it fails.
install-man5:
	for M in $(SEC5) ; do \
	    $(CP_MAN) $$M $D$(MAN5)/$$M ; \
	done
	rm -f $D$(MAN5)/motd.innd.5 $D$(MAN5)/motd.nnrpd.5
	$(LN_S) motd.news.5 $D$(MAN5)/motd.innd.5
	$(LN_S) motd.news.5 $D$(MAN5)/motd.nnrpd.5
	rm -f $D$(MAN5)/localgroups.5 $D$(MAN5)/nocem.ctl.5
	$(LN_S) $(MAN8)/docheckgroups.8 $D$(MAN5)/localgroups.5
	$(LN_S) $(MAN8)/perl-nocem.8 $D$(MAN5)/nocem.ctl.5
	if [ $D$(MAN5)/../man8 -ef $D$(MAN8) ] ; then \
	    rm -f $D$(MAN5)/localgroups.5 $D$(MAN5)/nocem.ctl.5 ; \
	    $(LN_S) ../man8/docheckgroups.8 $D$(MAN5)/localgroups.5 ; \
	    $(LN_S) ../man8/perl-nocem.8 $D$(MAN5)/nocem.ctl.5 ; \
	fi

# auth_krb5 is conditionally compiled, so handle it specially.  actsync(8)
# also covers actsyncd.
install-man8:
	for M in $(SEC8) ; do \
	    $(CP_MAN) $$M $D$(MAN8)/$$M ; \
	done
	rm -f $D$(MAN8)/actsyncd.8
	$(LN_S) actsync.8 $D$(MAN8)/actsyncd.8
	rm -f $D$(MAN8)/imapfeed.8
	$(LN_S) innfeed.8 $D$(MAN8)/imapfeed.8
	rm -f $D$(MAN8)/inpaths.8
	$(LN_S) ninpaths.8 $D$(MAN8)/inpaths.8
	rm -f $D$(MAN8)/sendxbatches.8
	$(LN_S) innxbatch.8 $D$(MAN8)/sendxbatches.8
	if [ x"$(KRB5_AUTH)" != x ] ; then \
	    $(CP_MAN) auth_krb5.8 $D$(MAN8)/auth_krb5.8 ; \
	fi

=== debian/changelog ===
inn2 (2.7.2~20240212-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:28:36 +0000

inn2 (2.7.2~20240212-1build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:15:07 +0000

inn2 (2.7.2~20240212-1build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:10:15 +0100

inn2 (2.7.2~20240212-1) unstable; urgency=medium

  * New upstream snapshot of the stable branch.
    + Get the Python link flags from python-config. (Closes: #1061315)

 -- Marco d'Itri <md@linux.it>  Mon, 12 Feb 2024 23:00:26 +0100

inn2 (2.7.2~20240120-1) unstable; urgency=medium

  * New upstream snapshot of the stable branch.

 -- Marco d'Itri <md@linux.it>  Wed, 24 Jan 2024 23:04:01 +0100

=== debian/control ===
Source: inn2
Section: news
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Marco d'Itri <md@linux.it>
Build-Depends: debhelper-compat (= 13), bison, flex, groff-base,
 libperl-dev, python3-dev, libdb-dev, libkrb5-dev, libpam0g-dev, libsasl2-dev,
 libsystemd-dev, pkg-config,
 libcanlock-dev, libsqlite3-dev, libssl-dev, zlib1g-dev,
Standards-Version: 4.6.2.0
Rules-Requires-Root: binary-targets
Homepage: https://www.eyrie.org/~eagle/software/inn/
Vcs-Git: https://salsa.debian.org/md/inn2.git
Vcs-Browser: https://salsa.debian.org/md/inn2

Package: inn2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 ${perl:Depends}, ${PERLAPI},
 cron | cron-daemon,
 default-mta | mail-transport-agent,
 time, procps,
 libencode-perl, libmime-tools-perl,
Pre-Depends: inn2-inews (= ${binary:Version})
Suggests: gnupg1, wget, libgd-perl, ${shlibs:Suggests}
Replaces: inn2-lfs, inn, innfeed, inn2-dev
Provides: news-transport-system
Conflicts: inn, innfeed
Description: 'InterNetNews' news server
 This package provides INN 2.x, which is a very complex news server
 daemon useful for big sites. The 'inn' package still exists for smaller
 sites which do not need the complexity of INN 2.x.
 .
 The news transport is the part of the system that stores the articles
 and the lists of which groups are available and so on, and provides
 those articles on request to users. It receives news (either posted
 locally or from a newsfeed site), files it, and passes it on to any
 downstream sites. Each article is kept for a period of time and then
 deleted (this is known as 'expiry').
 .
 By default Debian's INN will install in a fairly simple 'local-only'
 configuration.
 .
 In order to make use of the services provided by INN you'll have to
 use a user-level newsreader program such as pan. The newsreader is
 the program that fetches articles from the server and shows them to
 the user, remembering which the user has seen so that they don't get
 shown again. It also provides the posting interface for the user.

Package: inn2-inews
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: inews
Description: NNTP client news injector, from InterNetNews (INN)
 'inews' is the program that newsreaders call when the user wishes to
 post an article; it does a few elementary checks and passes the article
 on to the news server for posting.
 .
 This version is the one from Rich Salz's InterNetNews news transport
 system (which is also available as a Debian package).

Package: inn2-dev
Section: devel
Architecture: any
Depends: ${misc:Depends}
Breaks: manpages-dev (<< 6.03-2)
Conflicts: inn
Description: libinn.a library, headers and man pages
 You will only need this if you are going to compile programs that
 require the functions in libinn.a.

=== debian/rules ===
#!/usr/bin/make -f
SHELL+= -e

D := $(CURDIR)/debian/inn2
B := $(CURDIR)/build

include /usr/share/dpkg/architecture.mk
ifeq ($(DEB_HOST_ARCH_BITS),32)
configure_flags = --enable-largefiles
endif

# the upstream source needs to be copied in the build directory
src_files := $(shell find . -maxdepth 1 -not -name build -and \
	-not -name . -and -not -name debian -and -not -name .pc \
	-and -not -name .git \
	)

##############################################################################
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --builddirectory=$B

override_dh_auto_clean:
	rm -rf $B

override_dh_autoreconf:
	# do not run libtoolize because support/ltmain.sh has been customized
	LIBTOOLIZE=true \
	dh_autoreconf

override_dh_auto_configure:
	mkdir -p $B
	for dir in $(src_files); do [ -e $B/$$dir ] || cp -ldpR $$dir $B; done

	CONFIG_SHELL=/bin/sh \
	BZIP2=/bin/bzip2 \
	GZIP=/bin/gzip \
	PERL=/usr/bin/perl \
	PYTHON=/usr/bin/python3 \
	ac_cv_path_AWK=awk \
	ac_cv_prog_AWK=awk \
	ac_cv_path_CAT=cat \
	ac_cv_path_EGREP=egrep \
	ac_cv_path_OPENSSL=openssl \
	ac_cv_path_SED=sed \
	ac_cv_path_SORT=sort \
	ac_cv_path_UUSTAT=uustat \
	ac_cv_path_UUX=uux \
	ac_cv_path_GPGV=/usr/bin/gpgv \
	ac_cv_path_GPG=/usr/bin/gpg1 \
	ac_cv_path_PATH_GETFTP=wget \
	dh_auto_configure -- \
		--enable-uucp-rnews \
		--with-canlock \
		--with-perl \
		--with-python \
		--with-openssl \
		--with-sqlite3 \
		--prefix=/usr/lib/news \
		--libdir=/usr/lib/news \
		--mandir=/usr/share/man \
		--sysconfdir=/etc/news \
		--includedir=/usr/include \
		--with-db-dir=/var/lib/news \
		--with-filter-dir=/etc/news/filter \
		--with-log-dir=/var/log/news \
		--with-run-dir=/run/news \
		--with-spool-dir=/var/spool/news \
		--with-tmp-dir=/var/spool/news/incoming/tmp \
		--with-http-dir=/var/www/inn \
		--with-libperl-dir=/usr/share/perl5 \
		--with-bdb=/usr \
		--with-krb5=/usr \
		--with-sasl=/usr \
		--with-sendmail=/usr/sbin/sendmail \
		--with-zlib=/usr \
		$(configure_flags)

override_dh_auto_test:
	C_TAP_VERBOSE=1 \
	dh_auto_test

override_dh_auto_install:
	dh_auto_install --destdir=$D

override_dh_install:
	dh_movefiles --sourcedir=$(subst $(CURDIR)/,,$D)

#	move back to the main package these man pages
	mv $D-dev/usr/share/man/man3/libinn_uwildmat.3 \
		$D-dev/usr/share/man/man3/*.3pm \
		$D/usr/share/man/man3/

#	remove assorted crap and
#	make sure we don't ship active, active.times, newsgroups in place!
	rm -rf $D/usr/lib/news/bin/simpleftp $D/usr/share/man/man1/simpleftp.1\
		$D/usr/lib/news/doc/ $D/usr/include/ $D/etc/news/motd.* \
		$D/usr/lib/news/bin/rnews.libexec/ $D/usr/lib/news/share/ \
		$D/usr/lib/news/*.la \
		$D/etc/news/filter/*.tcl \
		$D/var/lib/news/* $D/run/ $D/var/www/

	install -m 755 extra/buildinnkeyring extra/ginpaths2 \
		$D/usr/lib/news/bin/

	perl -i -pe 's/^(pathhost:\s+).+/$${1}server.example.net/' \
		$D-inews/etc/news/inn.conf

	cp extra/active extra/newsgroups $D/usr/lib/news/examples/
	cp extra/news.conf $D/etc/rsyslog.d/
	mv $D/etc/news/filter/*.py $D/usr/share/doc/inn2/examples/filter/

override_dh_installdocs:
	dh_installdocs --sourcedir=$B

override_dh_installchangelogs:
	if [ -e ChangeLog ]; then \
	dh_installchangelogs ChangeLog ; \
	else \
	dh_installchangelogs ; \
	fi

override_dh_installinit:
	dh_installinit --noscripts --init-script=inn2

override_dh_installsystemd:
	dh_installsystemd --no-stop-on-upgrade

override_dh_fixperms:
	dh_fixperms -Xusr/lib/news/bin/innbind -Xusr/lib/news/bin/rnews
	chown root:root -R $D-inews/usr/lib/news/bin/rnews.libexec/

	# these files may contain passwords
	chown root:news \
		$D-inews/etc/news/passwd.nntp \
		$D/etc/news/incoming.conf \
		$D/etc/news/innfeed.conf \
		$D/etc/news/inn-radius.conf \
		$D/etc/news/inn-secrets.conf
	chmod 640 $D-inews/etc/news/passwd.nntp \
		$D/etc/news/incoming.conf \
		$D/etc/news/innfeed.conf \
		$D/etc/news/inn-radius.conf \
		$D/etc/news/inn-secrets.conf

	chmod -x $D/usr/lib/news/bin/control/*.pl $D/etc/news/*.local

	chmod u+w,o+r $D/usr/lib/news/bin/innbind

	chown -R news:news $D/var/spool/news/ $D/var/lib/news/ \
		$D/var/log/news/
	chmod -R g+w $D/var/spool/news/ $D/var/lib/news/ \
		$D/var/log/news/

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_shlibdeps:
	dh_shlibdeps --exclude=/usr/lib/news/bin/auth/passwd/auth_krb5 -- \
		-dSuggests $D/usr/lib/news/bin/auth/passwd/auth_krb5 \
		-dDepends

override_dh_gencontrol:
	dh_gencontrol -- \
	    -VPERLAPI=$$(perl -MConfig -e 'printf("perlapi-%s", $$Config{debian_abi} || $$Config{version})')

=== debian/tests/control ===
Tests: daemon
Depends: inn2-inews, inn2, systemd-sysv,
	perl, libipc-system-simple-perl, libpath-tiny-perl,
Restrictions: isolation-machine, needs-root, skippable
